function TMS_superDona_fitdivalent()

%C1data = [xlsread('MFile1','K2SO4','A2:A17')' xlsread('MFile1','K2SO4','A2:A17')' xlsread('MFile1','K2SO4','A2:A17')']*1000; %mM
C1data= [xlsread('#46 new electrode','MgCl2 #46','A2:A17')' xlsread('#46 new electrode','MgCl2 #46','A2:A17')' xlsread('#46 new electrode','MgCl2 #46','A2:A17')']*1000; %mM
C2overC1 = [5*ones(size(C1data))];
y1data=[xlsread('Activity','Mg+','G5:G20')' xlsread('Activity','Mg+','G5:G20')' xlsread('Activity','Mg+','G5:G20')'];
y2data=[xlsread('Activity','Mg+','G26:G41')' xlsread('Activity','Mg+','G26:G41')' xlsread('Activity','Mg+','G26:G41')'];
%y1data=[xlsread('Activity','Ca+','G5:G20')' xlsread('Activity','Ca+','G5:G20')' xlsread('Activity','Ca+','G5:G20')'];
%y2data=[xlsread('Activity','Ca+','G26:G41')' xlsread('Activity','Ca+','G26:G41')' xlsread('Activity','Ca+','G26:G41')'];
C1=C1data.*y1data;
C2=C2overC1.*C1data.*y2data;
%C2overC1 = 5.*C1data;%cf
%D1 = [1.957e-9*ones(1,16) 1.957e-9*ones(1,16) 1.957e-9*ones(1,16)];% K diffusivity
D1 = [0.792e-9*ones(1,16) 0.792e-9*ones(1,16) 0.792e-9*ones(1,16)]; %Ca diffusivity
%D1 = [0.706e-9*ones(1,16) 0.706e-9*ones(1,16) 0.706e-9*ones(1,16)];% Mg diffusivity
%D2 = [1.065e-9*ones(1,16) 1.065e-9*ones(1,16) 1.065e-9*ones(1,16)];%SO4 diffusivity
D2 = [2.032e-9*ones(1,16) 2.032e-9*ones(1,16) 2.032e-9*ones(1,16)];% Cl
%phiData=-[xlsread('MFile1','K2SO4','E2:E17')' xlsread('MFile1','K2SO4','F2:F17')' xlsread('MFile1','K2SO4','H2:H17')'];
phiData=-[xlsread('#46 new electrode','MgCl2 #46','E2:E17')' xlsread('#46 new electrode','MgCl2 #46','F2:F17')' xlsread('#46 new electrode','MgCl2 #46','G2:G17')'];
%phiData=-[xlsread('#46 new electrode','CaCl2 #46','E2:E17')' xlsread('#46 new electrode','CaCl2 #46','F2:F17')' xlsread('#46 new electrode','CaCl2 #46','G2:G17')'];
Cr_guess = 100; % mM
alpha_guess =  0.55; % effectiveness factor
D2overD1_guess=1;
options = optimset('Display','iter');

[betas,resnorm,res,exitflag,output,lambda,jac] = lsqcurvefit(@TMS_calculator,[Cr_guess alpha_guess D2overD1_guess],C1data,phiData,[0 0 0],[200 1 3],options,C2overC1,D1,D2);

[std,varresid,r2,cor,vcv,varinf]=regdata(betas,phiData+res,phiData,jac);

figure (3)
semilogx(C1data,-phiData,'o',C1data,-(phiData+res),'*')


function F = TMS_calculator(betas,C1,C2overC1,D1,D2)

% TMS 
Cr = betas(1); % mM
alpha = betas(2);
D2overD1=betas(3);
%alpha = 0.65; % "permselectivity" actually, effectiveness factor for leaks - intrinsic to membrane, independent of salt
R = 8.314; % 8.314 J/mol K
F1 = 1.609e-19*6.022e23; % C/mol
T = 298; % K
Z2=1;
Z1=2;
C1data= [xlsread('#46 new electrode','MgCl2 #46','A2:A17')' xlsread('#46 new electrode','MgCl2 #46','A2:A17')' xlsread('#46 new electrode','MgCl2 #46','A2:A17')']*1000; %mM
y1data=[xlsread('Activity','Mg+','G5:G20')' xlsread('Activity','Mg+','G5:G20')' xlsread('Activity','Mg+','G5:G20')'];
y2data=[xlsread('Activity','Mg+','G26:G41')' xlsread('Activity','Mg+','G26:G41')' xlsread('Activity','Mg+','G26:G41')'];
%y1data=[xlsread('Activity','Ca+','G5:G20')' xlsread('Activity','Ca+','G5:G20')' xlsread('Activity','Ca+','G5:G20')'];
%y2data=[xlsread('Activity','Ca+','G26:G41')' xlsread('Activity','Ca+','G26:G41')' xlsread('Activity','Ca+','G26:G41')'];

C1=C1data.*y1data;
C2=C2overC1.*C1data.*y2data;
%t1=Z1.*D1./(Z1.*D1+Z2.*D2);
t1=Z1./(Z1+Z2.*D2overD1);
tr=C1./C2;
%v1=2; %stoichiometric coefficient of the electrolyte
v1=1;
ep=(Cr./C1)./Z1./v1;
ef= (Cr./C2)./Z1./v1;
% lambdap=108+12*sqrt(3).*sqrt(27+4.*(ep).^3);
% gammap= (((lambdap.^(1/3))/6)-((2.*ep)./(lambdap).^(1/3))).^(-1);
% kp=(gammap).^(-2);
% lambdaf=108+12*sqrt(3).*sqrt(27+4.*(ef).^3);
% gammaf= (((lambdaf.^(1/3))/6)-((2.*ef)./(lambdaf).^(1/3))).^(-1);
% kf=(gammaf).^(-2);
theta=acos (0.5.*(ep./3).^-1.5);
gammap = 2*(sqrt(ep./3)).*cos(theta/3);
kp=(gammap).^(-1);
theta=acos (0.5.*(ef./3).^-1.5);
gammaf = 2*(sqrt(ef./3)).*cos(theta/3);
kf=(gammaf).^(-1);
Donnan = (1/Z2)*log(kp./kf);
%Diffusion =((D1-D2)/((Z2.*D2)+(Z1.*D1)))*log((tr.*kp+t1.*ef)./(kf+t1.*ef));
Diffusion =((1-D2overD1)/((Z2*D2overD1)+(Z1)))*log((tr.*kp+t1.*ef)./(kf+t1.*ef));
deltaPhi1 = ((R*T)/F1).*(alpha*Donnan+Diffusion);
F = deltaPhi1;
alphanew=(alpha*R*T)/F1;
figure(4)
datacursormode on
semilogx(C1,-deltaPhi1,'s', C1,-alphanew*Donnan,'*',C1,-(R*T/F1)*Diffusion,'^')
data= -deltaPhi1(1:16)'
